#include <mesham.h>
// PH Curve
#define MESHPeanoHandle int
void MESHGADfreePHCurve(MESHPeanoHandle);
MESHPeanoHandle MESHGADregisterPHCurve(char *,MESHShapeSpaceHandle);
void * MESHGADgetPHCurveelement(MESHPeanoHandle,int);
long long MESHGADgetPHCurveelementkey(MESHPeanoHandle,int);
long long MESHGADgetPHCurvetotalcells(MESHPeanoHandle);
int MESHGADgetPHCurveelementorderadded(MESHPeanoHandle,int index);
// PARAM FILE
void MESHGADregisterparamfile(char *,char *);
void * MESHGADgetparamvalue(char *, char *);
void MESHGADputparamvalue(char *, void *,char * );
void * MESHGADcopyparamvalues(char *, char *);
void MESHGADfreeparamfile(char *);
// SNAPSHOT FILE
void MESHGADregistersnapshotfmt1(char *,char *,int);
void MESHGADregistersnapshotfmt2(char *,char *,int);
void MESHGADregistersnapshotfmtHDF5(char *, char *,int);
void MESHGADfreesnapfile(char *);
int * MESHGADsnapshotgetnumparticles(char *);
int MESHGADsnapshotgetparticlesum(char *);
void MESHGADsnapshotsetnumparticles(char *,int *);
int * MESHGADsnapshotgetmynumparticles(char *);
double * MESHGADsnapshotgetparticlemass(char *);
void MESHGADsnapshotsetparticlemass(char *,double *);
int * MESHGADsnapshotgettotalnumparticles(char * );
void MESHGADsnapshotsettotalnumparticles(char * ,int *);
double MESHGADsnapshotgettime(char *);
void MESHGADsnapshotsettime(char *,double);
double MESHGADsnapshotgetredshift(char *);
void MESHGADsnapshotsetredshift(char *,double);
int MESHGADsnapshotgetfilespersnapshot(char *);
void MESHGADsnapshotsetfilespersnapshot(char *,int);
double MESHGADsnapshotgetboxsize(char *);
void MESHGADsnapshotsetboxsize(char *,double);
double MESHGADsnapshotgetomega0(char *);
void MESHGADsnapshotsetomega0(char *,double);
double MESHGADsnapshotgetomegalambda(char *);
void MESHGADsnapshotsetomegalambda(char *,double);
double MESHGADsnapshotgethubble(char *);
void MESHGADsnapshotsethubble(char *,double);
int MESHGADsnapshotgetentropy(char *);
void MESHGADsnapshotsetentropy(char *,int );

/* Particles */
typedef struct MESHGADparticlestruct
{
  float Pos[3];	
  float Mass;			
  float Vel[3];			
  float GravAccel[3];		
  float Potential;
  float OldAcc;
  unsigned int ID;		/* Assumed unsigned int for ID rather than long long */
  int Type;		    
  int Ti_endstep;     
  int Ti_begstep;    
  float GravCost;
  /*
  	This ignores the case of PMGRIDS, FLEXSTEPS etc.. the make file - would need to add these
  	extra fields in
  */
} MESHGADparticle;
void MESHGADsnapfmt1parseparticles(MESHGADparticle *,char *,int);
void MESHGADsnapfmt1saveparticles(MESHGADparticle *,char * ,int);
void MESHGADsnapfmt2parseparticles(MESHGADparticle *,char *,int);
void MESHGADsnapfmt2saveparticles(MESHGADparticle *,char * ,int);
void MESHGADsnapfmtHDF5saveparticles(MESHGADparticle * ,char * ,int );
void MESHGADsnapfmtHDF5parseparticles(MESHGADparticle * ,char * ,int );
