/*
	This determines if a data structure has memory allocated to it or not
*/
var allocated:=class rootType
(	
	var dynamic allocationtype;
	var dynamic declared:=false;
	var init:=method[]
	(
		super;
		startroot[];
		allocationtype:=new lowest;	
		this
	);
	var XsetUpPtr:=method[] 
	(		
		doTypeUpdate[];
		allocationtype.XsetUpPtr[];
	);
	var getAllocationType:=method[] allocationtype;
	var getDistributionPartition:=method[] 
	(
		updateTypeVar[];
		getPartition[];	
	);
	var getPartition:=method[] allocationtype.getPartition[];	
	var getDistribution:=method[] allocationtype.getDistribution[];
	
	var display:=method[] 
	(
		print "allocated -> ";
		core.display[];
	);
	
	var checkSharedSize:=method[] allocationtype.checkSharedSize[];
	var generateDynamicSizeCheck:=method[] allocationtype.generateDynamicSizeCheck[];
	var getPhysicalSize:=method[]
	{		
		updateTypeVar[];
		var n:=allocationtype.getPhysicalSize[];
		if (n==null)
		(
			var basesize:=core.getSize[];
			var perprocess:=new ArrayList[];
			var i;			
			for i from 0 to totalprocesses - 1
			(								
				if (((allocationtype.getheldon[])==false) ||  ((allocationtype.getheldon[]) :: commgroup))
				(
					perprocess.aadd[basesize.a];
				) else (
					if (i==((allocationtype.getheldon[]).getValue[]).a)
					(						
						perprocess.aadd[basesize.a];
					) else (
						perprocess.aadd[0];
					);
				);
			);
			return perprocess;
		) else (
			return n;
		);	
	};
	
	var getheldon:=method[]
	(
		return allocationtype.getheldon[];
	);
	
	var isDistributed:=method[] return allocationtype.isDistributed[];
	
	var setarg:=method[x,i]
	{
		if (i==0) 
		(			
	 		var v:=x.getTy[];	 	 		
			allocationtype:=v;					
		);						
	};
	
	var doTypeUpdate:=method[]
	(
		if (allocationtype.getVariable[]==null)
		( 							
			allocationtype.setVariable[getVariable[]];
			allocationtype.setHead[getChainStart[]];
		);	
	);
	
	var updateTypeVar:=method[]
	(				
		doTypeUpdate[];
		setUpTypes[];
	);
	
	var setUpTypes:=method[]
	(	
		if ((!(getPartition[]==null)) && (!(getDistribution[]==null)))
		(						
			getPartition[].setDistribution[getDistribution[]];	
			getPartition[].setUpBlock[];
		);		
	);
	
	var getDotValue:=method[x,i]
	{
		if (!(getPartition[]==null))
		(
			if (SemExpPhase==2) return new unknown[];
			updateTypeVar[];
			var allocv:= allocationtype.getDotValue[x,i];				
			if (!(allocv ==null)) return allocv;	// if the value is not null then return it, else call this on the actual type 
		);
		core.getDotValue[x,i];
	};	
		
	var generateAssignment:=method[x,i] 
	{			
		updateTypeVar[];
		var r:=allocationtype.generateAssignment[x,i];		
		if ((allocationtype :: lowest) || (r==null))
		(			
			return core.generateAssignment[x,i];
		);
		return r;
	};
	
	var generateAccess:=method[x,i] 
	{		
		updateTypeVar[];
		var r:=allocationtype.generateAccess[x,i];	
		if ((allocationtype :: lowest) || (r==null))
		(			
			return core.generateAccess[x,i];
		);
		return r;
	};
	
	var optimiseAssignment:=method[x,i] 
	{				
		updateTypeVar[];
		var r:=allocationtype.optimiseAssignment[x,i];	
		if ((allocationtype :: lowest) || (r==null))
		(
			return core.optimiseAssignment[x,i];
		);
		return r;
	};
	
	var optimiseAccess:=method[x,i] 
	{		
		updateTypeVar[];
		var r:=allocationtype.optimiseAccess[x,i];		
		if ((allocationtype :: lowest) || (r==null))
		(
			return core.optimiseAccess[x,i];
		);
		return r;
	};
	
	var getFormatMajor:=method[] allocationtype.getFormatMajor[];
	
	var generateMethodInvoke:=method[x] 
	{		
		updateTypeVar[];
		var r:=allocationtype.generateMethodInvoke[x];		
		if ((allocationtype :: lowest) || (r==false))
		(
			return core.generateMethodInvoke[x];
		);
		return r;
	};
	
	var generateCode:=method[] 
	{
		updateTypeVar[];	
		var r:=true;
		if (declared==false)
		(
			declared:=true;			
			r:= allocationtype.generateCode[];					
		);				
		if ((allocationtype :: lowest) || (r==false))
		(			
			return core.generateCode[];
		); 		
		return r;	
	};
	
	var generateDeclaration:=method[]
	{
		updateTypeVar[];		
		var r:= allocationtype.generateDeclaration[];				
		if ((allocationtype :: lowest) || (r==null))
		(			
			return core.generateDeclaration[];
		); 		
		return r;
	};
	
	var clone:=method[]
    {
    	var rety:=new allocated[];	
    	rety.allocationtype:=allocationtype.clone[];
    	rety.declared:=declared;
    	rety.alone:=alone;
    	rety.core:=core.clone[];
    	return rety;
    };
	
	var isallocated:=method[] true;
	
	var valid1:=method[] 
	(
		if (!alone) (core.valid81[];)	
	);	
	
	var valid41:=method[] 
	(
		if (!alone) (core.valid81[];)	
	);	
	
	var valid11:=method[] 
	(
		if (!alone) (core.valid81[];)	
	);	
	
	var valid31:=method[] 
	(
		if (!alone) (core.valid81[];)	
	);	
	
	var valid32:=method[] 
	(
		if (!alone) (core.valid81[];)	
	);
	
	var valid33:=method[] 
	(
		if (!alone) (core.valid81[];)	
	);
	
	var valid2:=method[] 
	(
		if (!alone) (core.valid81[];)	
	);
	
	var valid21:=method[] 
	(
		if (!alone) (core.valid81[];)	
	);	
	
	var valid82:=method[] 
	(
		if (!alone) (core.valid81[];)	
	);
	
	var valid83:=method[] 
	(
		if (!alone) (core.valid81[];)	
	);		
	
	var check:=method[v]
	(		
		if (v::thisclass) (return true;);
		return core.check[v];
	);
	
);
